#include "SendRecvThread.h"
#include "MySyncObject.h"		// CMySyncObjectg



//----------------------------------------------
// function
//    RXgN^
// parameter
//    ConnectionInfoRec *pConInfo	[in]@\ɕKvȏ
// return
//    Ȃ
//----------------------------------------------
CSendRecvThread::CSendRecvThread(ConnectionInfoRec *pConInfo)
{
	m_pConInfo = pConInfo;
	m_fIamZombie = FALSE;
	m_pSendData = NULL;			// Mf[^i[GA
	m_iSendDataSize = 0;		// Mf[^̃TCY
	m_pRecvData = NULL;			// Mf[^i[GA
	m_iRecvDataSize = 0;		// Mf[^̃TCY
}


//----------------------------------------------
// function
//    fXgN^
// parameter
//    Ȃ
// return
//    Ȃ
//----------------------------------------------
CSendRecvThread::~CSendRecvThread()
{
	SAFE_FREE(m_pSendData)		// Mf[^i[GAJ܂
	m_iSendDataSize = 0;
	SAFE_FREE(m_pRecvData)		// Mf[^i[GAJ܂
	m_iRecvDataSize = 0;
}

#define	RCVBUFSIZE		(1024)	// ɓǂލőMTCY
//----------------------------------------------
// function
//    @\Lq֐(DoRecv, DoSend̓eLq)
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
UINT CSendRecvThread::DoWork()
{
	BOOL		fRet = TRUE;
	char	    szRecvBuffer[RCVBUFSIZE + 1];	// Mobt@
	int			iRecvSize;
	fd_set		rfds, wfds;
	struct timeval     tv;
	char		*pcData = NULL;		// Mf[^
	int			iSendSize = 0;		// Mf[^TCY

	fprintf(stderr, "DoWork()\n");
	while (!m_fStopFlag)
	{
		// M̃f[^ȂΑMf[^邩ׂ
		if (iSendSize == 0)
			iSendSize = GetSendData(&pcData);

		tv.tv_sec = 0;
		tv.tv_usec = 10 * 1000;							// 10msec
		FD_ZERO(&rfds);
		FD_ZERO(&wfds);
		FD_SET(m_pConInfo->fdClient, &rfds);
		// Mf[^ƂM\pfd_setɃZbg
		if (iSendSize > 0)
			FD_SET(m_pConInfo->fdClient, &wfds);
		select(FD_SETSIZE, &rfds, NULL, NULL, &tv);		// ^CAEg܂SleepƓ
		// M(DoRecv)
		if (FD_ISSET(m_pConInfo->fdClient, &rfds))
		{
			memset(szRecvBuffer, 0, sizeof(szRecvBuffer));
			if ((iRecvSize = recv(m_pConInfo->fdClient, szRecvBuffer, RCVBUFSIZE, 0)) <= 0)
			{
				m_pConInfo->pCMySyncObject->Lock();
				if (iRecvSize == 0)
					DispErrorMsg("Disconnected");
				else
					DispErrorMsg("Err:recv");
				m_pConInfo->pCMySyncObject->UnLock();
				fRet = FALSE;
				break;
			}
			else
			{
#if 0
				fprintf(stderr, "%s\n", szRecvBuffer);
#else
				// Mf[^(UTF-8)o
				SetRecvData(szRecvBuffer, iRecvSize);
				// UTF-8ŎM̂ŁASJISɕϊĕ\
				int		iSize = 0;
				LPBYTE	pbDest = NULL;
				ConvUtf8toSJis((LPBYTE)szRecvBuffer, NULL, &iSize);
				pbDest = (LPBYTE)calloc(iSize, sizeof(BYTE));
				ConvUtf8toSJis((LPBYTE)szRecvBuffer, pbDest, &iSize);
				m_pConInfo->pCMySyncObject->Lock();
				fprintf(stderr, "%s\n", pbDest);
				m_pConInfo->pCMySyncObject->UnLock();
				SAFE_FREE(pbDest)
#endif
			}
		}
		// M(DoSend)
		if (FD_ISSET(m_pConInfo->fdClient, &wfds))		// M\Ȃsend{
		{
			if (send(m_pConInfo->fdClient, pcData, iSendSize, 0) != iSendSize)
			{
				DispErrorMsg("Err:send");
				fRet = FALSE;
				break;
			}
			SAFE_FREE(pcData)							// Mf[^ȂɃZbg
			iSendSize = 0;
		}
	}
	m_pConInfo->pCMySyncObject->Lock();
	m_fIamZombie = TRUE;
	m_pConInfo->pCMySyncObject->UnLock();
	SAFE_FREE(pcData)							// Mf[^ȂɃZbg
	iSendSize = 0;
	return((fRet == TRUE) ? 0 : -1);
}

//----------------------------------------------
// function
//		Mf[^̐ݒ
// parameter
//		char	*pcData	[in]Mf[^
//		int		iSize	[in]f[^
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::SetSendData(char *pcData, int iSize)
{
	BOOL	fRet = FALSE;

	m_pConInfo->pCMySyncObject->Lock();
	// Õf[^ǂ݂ĂȂƂ̓G[ɂ
	if (m_iSendDataSize == 0)
	{
		m_pSendData = (char *)calloc(iSize, sizeof(char));
		memcpy(m_pSendData, pcData, iSize);
		m_iSendDataSize = iSize;
		fRet = TRUE;
	}
	m_pConInfo->pCMySyncObject->UnLock();
	return(fRet);
}

//----------------------------------------------
// function
//		Mf[^̎擾
// parameter
//		char **ppcData	[in/out]Mf[^
// return
//		f[^
//----------------------------------------------
int CSendRecvThread::GetSendData(char **ppcData)
{
	int		iSize = 0;

	m_pConInfo->pCMySyncObject->Lock();
	if (m_iSendDataSize > 0)
	{
		*ppcData = (char *)calloc(m_iSendDataSize, sizeof(char));
		memcpy(*ppcData, m_pSendData, m_iSendDataSize);
		iSize = m_iSendDataSize;
		SAFE_FREE(m_pSendData)		// ǂݏosƂZbg
			m_iSendDataSize = 0;
	}
	m_pConInfo->pCMySyncObject->UnLock();
	return(iSize);
}

//----------------------------------------------
// function
//		Mf[^̐ݒ
// parameter
//		char	*pcData	[in]Mf[^
//		int		iSize	[in]f[^
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendRecvThread::SetRecvData(char *pcData, int iSize)
{
	BOOL	fRet = FALSE;

	m_pConInfo->pCMySyncObject->Lock();
	// Õf[^ǂ݂ĂȂƂ̓G[ɂ
	if (m_iRecvDataSize == 0)
	{
		m_pRecvData = (char *)calloc(iSize, sizeof(char));
		memcpy(m_pRecvData, pcData, iSize);
		m_iRecvDataSize = iSize;
		fRet = TRUE;
	}
	m_pConInfo->pCMySyncObject->UnLock();
	return(fRet);
}

//----------------------------------------------
// function
//		Mf[^̎擾
// parameter
//		char **ppcData	[in/out]Mf[^
// return
//		f[^
//----------------------------------------------
int CSendRecvThread::GetRecvData(char **ppcData)
{
	int		iSize = 0;

	m_pConInfo->pCMySyncObject->Lock();
	if (m_iRecvDataSize > 0)
	{
		*ppcData = (char *)calloc(m_iRecvDataSize, sizeof(char));
		memcpy(*ppcData, m_pRecvData, m_iRecvDataSize);
		iSize = m_iRecvDataSize;
		SAFE_FREE(m_pRecvData)		// ǂݏosƂZbg
		m_iRecvDataSize = 0;
	}
	m_pConInfo->pCMySyncObject->UnLock();
	return(iSize);
}

//----------------------------------------------
// function
//    ̃Xbh̓]rԂ
//	  ʃXbhQƂ
// parameter
//    Ȃ
// return
//    0: -1:G[
//----------------------------------------------
BOOL CSendRecvThread::IsZombie()
{
	BOOL	fRet;

	m_pConInfo->pCMySyncObject->Lock();
	fRet = m_fIamZombie;
	m_pConInfo->pCMySyncObject->UnLock();
	return(fRet);
}
